longint GetValNumber(char** Vals, char* String, longint Number, bool Force = true)
{
	longint i;
	for (i = 0;i < Number;i++)
	{
		if (stricmp(Vals[i], String) == 0)
		{
			return(i);
		}
	}
	if (Force)
	{
		qprintf("Value not found: %s\n", String);
		quitprog();
	}
	return(-1);
}

char *buffer;
longint buffersize;

longint CountSetLines(FILE* fFile)
{
	longint Number = 0;
	fseek(fFile, 0, SEEK_SET);
	fgets(buffer, (int) buffersize, fFile);
	fgets(buffer, (int) buffersize, fFile);
	while (!feof(fFile))
	{
		if (fgets(buffer, (int) buffersize, fFile) == NULL)
		{
			break;
		}
		if (buffer[0] != 10 && buffer[0] != 13)
		{
			Number++;
		}
	}
	fseek(fFile, 0, SEEK_SET);
	fgets(buffer, (int) buffersize, fFile);
	fgets(buffer, (int) buffersize, fFile);

	return(Number);
}

char** Vals;

void ProcessLine(FILE *fFile, void (*ProcessFunction)(char* Vals[], void* pSource, void* pTempSource, longint Number, bool header), void* pSource, void* pTempSource, bool header)
{
	bool nextval = false;
	longint i, j, k;
	longint inQuotes = false;

	static unsigned longint valcount;

	do
	{
		fgets(buffer, (int) buffersize, fFile);
	} while (buffer[0] == 10 || buffer[0] == 13);

	Vals[0] = &buffer[0] + (inQuotes = (buffer[0] == '"'));
	j = 1;
	k = (longint) strlen(buffer);
	for (i = inQuotes;i < k;i++)
	{
		if (buffer[i] == 10 || buffer[i] == 13)
		{
			buffer[i] = 0;
		}
		else if (inQuotes == 0 && (buffer[i] == 32 || buffer[i] == 9))
		{
			nextval = true;
			buffer[i] = 0;
			if (buffer[i + 1] == '"')
			{
				inQuotes = 1;
				buffer[++i] = 0;
			}
		}
		else if (nextval)
		{
			if (buffer[i] == '"' && inQuotes == 1)
			{
				buffer[i] = 0;
				inQuotes = 0;
			}
			nextval = false;
			Vals[j] = &buffer[i];
			j++;
		}
		else if (buffer[i] == '"' && inQuotes == 1)
		{
			buffer[i] = 0;
			inQuotes = 0;
		}
	}

	if (header)
	{
		valcount = j;
	}
	else if (valcount != j)
	{
		qprintf("Invalid Number in Database (%" PRINTFINT " instead of %" PRINTFINT ")\n", j, valcount);
	}
	
	ProcessFunction(&Vals[0], pSource, pTempSource, j, header);
}

template <class T, class U> longint SourceInit(char* FileName, T** ThisSource, U** TempSource, longint* SourceCount, void (*ProcessFunction)(char** Vals, void* pSource, void* pTempSource, longint Number, bool header), longint AddMem = 0, bool NoAlloc = false)
{
	longint i;
	FILE* hFile;

	qprinta(DEBUG_BNF_SPLIT)("\n\n");
	qprinta(2)("Opening File (%s)\t", FileName);
	hFile = fopen(FileName, "r");
	if (hFile == 0)
	{
		qprintf("FAILED\n");
		return(1);
	}

	fseek(hFile, 0, SEEK_END);
	buffersize = ftell(hFile);
	buffer = (char*) mallocl(buffersize + 1, "SourceInit-buffer");
	Vals = (char**) mallocl(buffersize / 2 * sizeof(char*), "SourceInit-Vals");
	fseek(hFile, 0, SEEK_SET);

	qprinta(2)("OK\nReading List\t\t\t");
	ProcessLine(hFile, ProcessFunction, NULL, NULL, true);
	*SourceCount = CountSetLines(hFile);
	qprinta(2)("%" PRINTFINT "\n", *SourceCount);

	Source.dwSourceCountMax = max(Source.dwSourceCountMax, (*SourceCount + AddMem) * sizeof(longint));
	if (!NoAlloc)
	{
		SetNewIdent("SourceInit-Source");
		*ThisSource = new T[*SourceCount + AddMem];
		if (TempSource)
		{
			*TempSource = new U[*SourceCount + AddMem];
		}
	}
	qprinta(2)("\t( ");

	for (i = 0;i < *SourceCount;i++)
	{
		ProcessLine(hFile, ProcessFunction, (ThisSource == NULL ? NULL : &((*ThisSource)[i])), (TempSource == NULL ? NULL : &((*TempSource)[i])), false);
		if (ThisSource) {qprinta(2)("%s ", (*ThisSource)[i].Name.buffer);}
	}
	qprinta(2)(")\n\n");

	fclose(hFile);

	freel(buffer);
	freel(Vals);

	return(0);
}

longint FillArrayFromFile(char* FileName, longint* Target, longint MinLen)
{
	FILE* fp;
	longint i = 0, j;
	char* buffer;
	longint buffersize;
	longint temp;

	fp = fopen(FileName, "r");

	fseek(fp, 0, SEEK_END);
	buffersize = ftell(fp);
	buffer = (char*)  mallocl(buffersize + 1, "FillArrayFromBFile-buffer");
	fseek(fp, 0, SEEK_SET);

	while (!feof(fp))
	{
		fgets(buffer, (int) buffersize, fp);
		sscanf(buffer, "%" PRINTFINT "\t%" PRINTFINT "\n", &temp, &Target[i]);
		i++;
	}
	for (j = i;j < MinLen;j++)
	{
		Target[j] = Target[i - 1];
	}

	freel(buffer);

	return(0);
}
