#ifdef DUMP_SOURCE
#ifdef CACHE_LINE_ALIGN

longint run_check_exception(unsigned longint code, struct _EXCEPTION_POINTERS *ep)
{
	unsigned long retTmp;
	static longint lastvar = -1;
	static size_t lastpage;
	static void* lasteip = NULL;
	longint var;
	size_t thispage, dualpage = 0;
	if (code == EXCEPTION_GUARD_PAGE)
	{
		thispage = (ep->ExceptionRecord->ExceptionInformation[1] - VIRTUAL_COMPACT_BASE) / dwPageSize;
		var = dwPageMap[thispage];

		if (lasteip && ep->ExceptionRecord->ExceptionAddress == lasteip && var == lastvar)
		{
			if (dualpage)
			{
				retTmp = VirtualProtect((void*) (VIRTUAL_COMPACT_BASE + dualpage * dwPageSize), dwPageSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
			}
			dualpage = lastpage;
		}
		else if (lastpage)
		{
			retTmp = VirtualProtect((void*) (VIRTUAL_COMPACT_BASE + lastpage * dwPageSize), dwPageSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
			if (dualpage)
			{
				retTmp = VirtualProtect((void*) (VIRTUAL_COMPACT_BASE + dualpage * dwPageSize), dwPageSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
				dualpage = 0;
			}
		}
		lasteip = ep->ExceptionRecord->ExceptionAddress;

		lastpage = thispage;

		if (var != -1 && lastvar != -1 && var != lastvar)
		{
			dwMemAccessCount++;

			if (dwVarAccess[var * dwVarCount + lastvar] == dwMemAccessMax)
			{
				dwMemAccessMax++;
			}

			qprinta(3)("Access: %" PRINTFINT ", Var: %" PRINTFINT ", Last Var: %" PRINTFINT "\n", ep->ExceptionRecord->ExceptionInformation[1], var, lastvar);
			dwVarAccess[var * dwVarCount + lastvar]++;
			dwVarAccess[var * dwVarCount + var]++;
		}

		lastvar = var;
		return(EXCEPTION_CONTINUE_EXECUTION);
	}
	else
	{
		return(EXCEPTION_CONTINUE_SEARCH);
	}
}

#endif

inline longint run_init_a(size_t &CompactSize, longint &VirtualAllocError, longint &oldMallocID, size_t &oldnTreeSize, longint &oldMallocCount)
{
	CompactSourceAllocated = (VirtualAlloc((void*) VIRTUAL_COMPACT_BASE, CompactSize, MEM_RESERVE, PAGE_READWRITE) != NULL);
	if (CompactSourceAllocated)
	{
		if (VirtualAlloc((void*) VIRTUAL_COMPACT_BASE, CompactSize, MEM_COMMIT, PAGE_READWRITE) == NULL)
		{
			VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE);
		}
		else
		{
			VirtualAllocError = 0;
		}
	}

	if (VirtualAllocError)
	{
		qprintf("Memmory Allocation Error\n");
		breakpoint("run_init");
	}

	((char*) VIRTUAL_COMPACT_BASE)[0] = 0;
	EmptyString = (char*) VIRTUAL_COMPACT_BASE;

	MallocID = oldMallocID;
	nTreeSizeMax = oldnTreeSize;
	bnf::pTree = 0;
	MallocLogCount = oldMallocCount;

	ReserveHigh = 1;
	if (SourceInit() == 1) {return(1);}
	ReserveHigh = 0;

	return(0);
}

#endif

longint run_init()
{
	LARGE_INTEGER init_start, init_end, init_bnfpassed;

	QueryPerformanceCounter(&init_start);
	if (fConsistenceCheck == false)
	{
		qprintf("Initializing Data...\n");
	}

	if (MustRebuild || TestScript)
	{
#ifdef INCLUDE_REBUILD
		UnReAlloc();
		if (!bnfinitdone)
		{
			qprintf("Initializing Script Grammar\n");
			if (bnf::bnfinit(SCRIPT_FILE, &ScriptGrammar))
			{
				qprintf("Error initialising Script Grammer\n");
				return(1);
			}
			bnfinitdone = true;
		}
#endif
	}

	Source.lpSymbolStart = ScriptGrammar.pSymbolNames;

	if (RedirectSymbols())
	{
		return(1);
	}

#ifdef ALLOW_TEST_SCRIPT
	if (TestScript)
	{
		longint DebugOld;
		tempoutcommon[0] = 0;

		if (bnf::SplitFile("Build\\TestScript.scr", &ScriptGrammar, false) == 0)
		{
			parser::OptimizeScript2(Source.lpSymbolStart, NULL, &bnf::pTree);
			DebugOld = qon_DebugOutput;
			qon_DebugOutput = 1;
			qprintf("Running Testscript:\n");
			RunScript(&cDumpChar, &eDumpEquip, &tempoutstring, bnf::pTree, "Testscript");
			qon_DebugOutput = DebugOld;

			freel(bnf::pTree);
			bnf::pTree = NULL;
			bnf::bnfreset();

			qprintf("\n\nText:\n\n%s", tempoutstring.buffer);
		}

		FreeRedirectedSymbols();

		return(-1);
	}
#endif

	if (MustRebuild && Rebuilded == 0)
	{
		qprintf("Initializing Source\n");
#ifdef DUMP_SOURCE_LOAD
		qprintf("Rebuilding as Dump could not be loaded correctly\n");
#endif

#ifndef INCLUDE_REBUILD
		qprintf("Cannot Rebuild AS Rebuild Code is not included!\n");
		return(1);
#endif

		QueryPerformanceCounter(&init_bnfpassed);

#ifdef DUMP_SOURCE
		longint oldMallocID, oldMallocCount;
		size_t oldnTreeSize;

		oldMallocID = MallocID;
		oldnTreeSize = nTreeSizeMax;
		oldMallocCount = MallocLogCount;
#endif

#ifdef INCLUDE_REBUILD
		if (SourceInit() == 1) {return(1);}
		qprintf("Done\n");
#endif

#ifdef DUMP_SOURCE
		size_t CompactSize;
		
		if (CompactSourceAllocated)
		{
			if (VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE) == false)
			{
				qprintf("Could not free Virtual Memmory - Cannot rebuild");
				breakpoint("run_init");
			}
		}
		qprintf("Rebuilding Compact Source...\n\t");

		CompactSize = PackMallocIDS(oldMallocID);

		longint VirtualAllocError = 1;

		SourceExit();
		if (run_init_a(CompactSize, VirtualAllocError, oldMallocID, oldnTreeSize, oldMallocCount))
			return(1);

#ifdef CACHE_LINE_ALIGN
		if (fUseProfiledAlining)
		{
			unsigned long retTmp;
			retTmp = VirtualProtect((void*) VIRTUAL_COMPACT_BASE, CompactSize, PAGE_READWRITE | PAGE_GUARD, &retTmp);
			qprintf("\nDoing Runtime Analysis...\n");

			clsChar* CDummy = (clsChar*) malloc(sizeof(clsChar));
			CharTemplate* CTDummy = (CharTemplate*) malloc(sizeof(CharTemplate));

			ZeroMemory(CDummy, sizeof(clsChar));
			ZeroMemory(CTDummy, sizeof(CharTemplate));

			CDummy->CreationTemplate = CTDummy;
			CTDummy->MinLevel = 0;
			CTDummy->MaxLevel = 50;
			CTDummy->Monster = -1;
			CTDummy->Mixed = -1;
			CTDummy->MonsterName = -1;
			CTDummy->Race = -1;
			BenchmarkMode = 1;

			fNoAutoSave = true;
			fDropMsg = true;
			__try
			{
#ifdef BUILD_INTEL
				clsGrammar* TempGrammar = (clsGrammar*) malloc(sizeof(clsGrammar));
				CopyMemory(TempGrammar, &ScriptGrammar, sizeof(clsGrammar));
				SymbolsRedirected = false;
				Intel_Create_Char((void*) CDummy);
				CopyMemory(&ScriptGrammar, TempGrammar, sizeof(clsGrammar));
				free(TempGrammar);
				SymbolsRedirected = true;
#else
				CreateCharContextA(&CDummy->Context);
				isaacinitrand();
				CreateChar(CDummy);
				DeleteCharContextA(&CDummy->Context, false);
				CDummy->~clsChar();
#endif
			} __except (run_check_exception(GetExceptionCode(), GetExceptionInformation())){}
			fNoAutoSave = false;

			CTDummy->~CharTemplate();
			free(CDummy);
			free(CTDummy);
			fDropMsg = false;

			while (kbhit()) {getch();}
			fflush(stdin);

			BenchmarkMode = 0;

			retTmp = VirtualProtect((void*) VIRTUAL_COMPACT_BASE, CompactSize, PAGE_READWRITE, &retTmp);

			VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE);
			CompactSize = RepackMallocIDS();

			qprintf("Done\n\nReinitializing...\n\t");

			SourceInitDone = false;
			if (run_init_a(CompactSize, VirtualAllocError, oldMallocID, oldnTreeSize, oldMallocCount))
				return(1);
		}

#endif

		ReleaseMallocIDS();
		qprintf("Done\n");

#endif

		QueryPerformanceCounter(&init_end);

		qprinta(DEBUG_SIZES)("Init took %" PRINTFINT " usec\n\n", (longint) ((init_end.QuadPart - init_start.QuadPart) * 1000000 / qwFreq));

#ifdef DUMP_SOURCE
#ifndef GCC_RUNTIME
		if (SaveAllocs(CompactSize, init_bnfpassed.QuadPart, init_end.QuadPart, SOURCE_FILE, &Source, sizeof(clsSource), ScriptGrammar.pSymbolNames, ScriptGrammar.SymbolNameSize, (longint) 0))
		{
			qprintf("Could not Dump Source into File\n");
		}
#else
		qprintf("Cannot Dump Using GCC Runtime!\n");
#endif
#endif

		Rebuilded = 1;
	}
	else
	{
		if (fConsistenceCheck == false)
		{
			qprintf("No Source Rebuild required\n");
		}
	}

	RedirectSymbols();

#ifdef MALLOC_LOG
	if (fConsistenceCheck == false)
	{
		qprintf("Memmory Allocs after Init: %" PRINTFINT "\n", MallocLogCount);
	}
#endif

	return(0);
}

longint run_worktype()
{
	longint i, j, k, l;
	if (worktype == 2)
	{
		ListSpells();
		return(-1);
	}

	if (worktype == 1)
	{
		p<longint> mprob;
		
		j = AdvancedRand(isaacseeds[0], Source.MonsterTypeSourceCount, &FixedProb, 0, (char*) &Source.MonsterTypeSource[0].Name.buffer, sizeof(clsMonsterTypeSource), "Typ whlen!", 1, 1);
		mprob = (longint*) mallocl(Source.MonsterSourceCount * sizeof(longint), "run-mprob");
		for (i = 0;i < Source.MonsterSourceCount;i++)
		{
			if (Source.MonsterSource[i].Type == j)
			{
				mprob[i] = 1;
			}
			else
			{
				mprob[i] = 0;
			}
		}
		l = AdvancedRand(isaacseeds[0], Source.MonsterSourceCount, mprob, sizeof(longint), (char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonsterSource), "Monster whlen!", 1, 1);

		qprintf("\n\n\n%s:\n\n", Source.MonsterSource[l].Name.buffer);
		longint a, b;
		for (k = 0;k < 11;k++)
		{
			qprintf("Template: %s\n", Source.TemplateSource[k].Name.buffer);
			for (j = 0;j < 4;j++)
			{
				a = DetermineCR(l, j, k, &b, 0);
				if (a <= 60)
				{
					qprintf("\tHD Inc: %2" PRINTFINT " - Possible CRs: %2" PRINTFINT " - %2" PRINTFINT "\n", j, a, b);
				}
			}
			qprintf("\n");
		}

		return(-1);
	}
	return(0);
}

void run_alloc()
{
	longint i;
	SetNewIdent("run_alloc-Characters");
	Characters = new clsChar[(longint) GT.CharCount];
	SetNewIdent("run_alloc-CT");
	CTs = new CharTemplate[(longint) GT.CharCount];
	Screens = (HANDLE*) mallocl(((longint) GT.CharCount + 1) * sizeof(HANDLE), "run-Screen");
	SetNewIdent("run_alloc_TempTables");
	FullTables = new string[(longint) GT.CharCount];
	if (CTs == 0 || Characters == 0)
	{
		qprintf("Memmory Allocation Error\n");
		quitprog();
	}

	for (i = 0;i < GT.CharCount;i++)
	{
		Characters[i].CreationTemplate = &CTs[i];
	}
}

void run_cleanup(longint cleanup_screans = 1, longint free_mem = 1, longint finish_up = 1)
{
	longint i;
	if (cleanup_screans)
	{
		if (fConsistenceCheck == false)
		{
			SetConsoleActiveScreenBuffer(Screens[0]);
			ClearConsole(0);
		}
		for (i = 1;i <= GT.CharCount;i++)
		{
			CloseHandle(Screens[i]);
		}
	}

	if (free_mem)
	{
		delete[] Characters;
		delete[] CTs;
		delete[] FullTables;
		FullTable.~string();
		freel(Screens);
	}

	if (finish_up)
	{
		FreeRedirectedSymbols();
	}
}

longint threadloop = 0;

longint run_templates()
{
	longint i, j, k;

	GT.CharCount = random(isaacseeds[0], CreatureMin, CreatureMax, "Anzahl eingeben!", 0);

	BaseFrame.AllowEpic = (FullCRMax > 20);

	run_alloc();
	SRs = (longint*) mallocl((longint) GT.CharCount * sizeof(longint), "run-SR");

	if (GT.CharCount > 1)
	{
		GT.FullCR = random(isaacseeds[0], FullCRMin, FullCRMax, "HG Eingeben!", 0);

		for (i = 0;i < GT.CharCount;i++)
		{
			SRs[i] = (longint) GT.FullCR;
			for (j = (longint) GT.CharCount;j > 1;j /= 2)
			{
				SRs[i]--;
				if (SRs[i] > 5)
				{
					SRs[i]--;
				}
				if (SRs[i] > 10)
				{
					SRs[i]--;
				}
				SRs[i] = max(0, SRs[i]);
			}
		}

		i = 0;
		j = (longint) GT.CharCount - 1;
		while (i < j)
		{
			k = random(isaacseeds[0], 0, (longint) GT.FullCR / 5 + 1, "HG Abweichung bei Gegner", 0);
			if (random(isaacseeds[0], 0, 1, "Abweichung umkehren?", 0) == 1)
			{
				k *= -1;
			}
			if (SRs[i] + k < GT.FullCR && SRs[j] - k > 0)
			{
				SRs[i] += k;
				SRs[j] -= k;
			}
			i++;
			j--;
		}
	}


	for (i = 0;i < GT.CharCount;i++)
	{
		ZeroMemory(&CTs[i], sizeof(CharTemplate));
		CTs[i].AttributePreset = 0;
		if (ChooseClass && (!manual))
		{
			CTs[i].AttributeType = 1;
		}
		else
		{
			CTs[i].AttributeType = -1;
		}
		if (BaseFrame.DrawType == -1)
		{
			CTs[i].AttributeType = 0;
		}
		CTs[i].Class = NULL;
		CTs[i].MinLevel = SRs[i];
		CTs[i].MaxLevel = SRs[i];
		CTs[i].Monster = (CreatureType == -1 ? -1 : min(1, CreatureType) && CreatureType != 4);
		CTs[i].MonsterName = -1;
		CTs[i].Mixed = (CreatureType == 2);
		CTs[i].Treasure = (CreatureType == 3);
		CTs[i].NPCClass = (CreatureType == 4);
		CTs[i].TreasureMax = TreasureMax;
		CTs[i].TreasureMin = TreasureMin;
		CTs[i].Race = -1;
		CTs[i].Life = -100;
		CTs[i].Reproduce = 0;
	}

	if (GT.CharCount == 1)
	{
		CTs[0].MinLevel = FullCRMin;
		CTs[0].MaxLevel = FullCRMax;
		GT.FullCR = -1;
	}

	freel(SRs);

	if (loop && dwThreads > 1 && GT.CharCount == 1)
	{
		CharTemplate tmp;
		CopyMemory(&tmp, CTs, sizeof(CharTemplate));
		ZeroMemory(CTs, sizeof(CharTemplate));

		run_cleanup(0, 1, 0);
		GT.CharCount = dwThreads;
		run_alloc();
		for (i = 0;i < GT.CharCount;i++)
		{
			CopyMemory(&CTs[i], &tmp, sizeof(CharTemplate));
		}
		threadloop = 1;
	}

	return(0);
}

longint run_reproduce()
{
	char VCheck[4];
	string fullrepfile = "Save\\";
	char ibuffer[SMALL_BUFFER_LEN];
	longint i;

	ZeroMemory(VCheck, 4);

	reproduce = 0;
	readreproduce = 1;
	*prepos = 0;

	if (UseReHeaderSave)
	{
		GT.CharCount = 1;
		run_alloc();
		CopyMemory(Characters[0].CreationTemplate, &ReHeaderSave, sizeof(CharTemplate));
		readreproducefinished = 1;
		UseReHeaderSave = false;
	}
	else
	{
		qprintf("Gespeicherte Dateien:\n");
		ListDir("save\\*.*");
		qprintf("\nDateinamen zum reproduzieren eingeben! ");
		fgets(ibuffer, 1023, stdin);
		sscanf(ibuffer, "%s\n", refname);

		fullrepfile += refname;
		str_replace('\\', '-', fullrepfile.buffer + 5);
		reRead = fopen(fullrepfile.buffer, "rb");
		if (reRead == 0)
		{
			qprintf("Error: File not found: %s\n\tTrying %s.rep\n", refname, refname);
			fullrepfile += ".rep";
			reRead = fopen(fullrepfile.buffer, "rb");
			if (reRead == 0)
			{
				qprintf("Fatal Error: Could not open File\n");
				readreproduce = readreproducea = 0;
				return(1);
			}
		}

		fread(VCheck, 4, 1, reRead);
		if (strncmp(VCheck, "DNDR", 4) != 0)
		{
			qprintf("File is not a DND Reproduce File\nExiting\n");
			return(1);
		}

		fread(&GT, sizeof(GroupTemplate), 1, reRead);
		run_alloc();
		for (i = 0;i < GT.CharCount;i++)
		{
			fread(Characters[i].CreationTemplate, sizeof(CharTemplate), 1, reRead);
			Characters[i].CreationTemplate->Reproduce = 1;
		}
	}

	return(0);
}

longint run_screenbuffer()
{
	longint i;
	COORD Size;

	CONSOLE_SCREEN_BUFFER_INFO Info;
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &Info);
	Size.X = (short) max((DWORD) Info.dwMaximumWindowSize.X, (DWORD) 125);
	Size.Y = (short) max((DWORD) Info.dwMaximumWindowSize.Y, (DWORD) 500);

	Screens[0] = GetStdHandle(STD_OUTPUT_HANDLE);
	
	for (i = 1;i <= GT.CharCount;i++)
	{
		Screens[i] = CreateConsoleScreenBuffer(GENERIC_WRITE, 0, NULL, CONSOLE_TEXTMODE_BUFFER, NULL);
		if (fConsistenceCheck == false)
		{
			SetConsoleScreenBufferSize(Screens[i], Size);
		}
		ClearConsole(i);
		if (Screens[i] == INVALID_HANDLE_VALUE)
		{
			qprintf("Could not create screen buffer\n");
			quitprog(false);
		}
	}

	return(0);
}

volatile longint loopcount = 0;
__int64 TotalTime = 1, TotalDisplayTime = 1;
LARGE_INTEGER full_start, full_now;
bool forcethreadexit;
volatile longint threadsexited;

unsigned long __stdcall run_main_do(void* data)
{
	longint i, j;

	longint start = ((clsThreadData*) data)->start;
	longint end = ((clsThreadData*) data)->end;
	bool primary = ((clsThreadData*) data)->primary;

	longint retVal = 0;

	longint displayloopcount = 0;

	longint finishreadreproduce = readreproduce;

	if (fConsistenceCheck) loopdisplay = 0;

	if (primary && BenchmarkMode)
	{
		qprintf("Running Benchmark... (5000 Caching Runs / 30000 Benchmark Runs)\n\n");
	}

	for (i = start;i < end;i++)
	{
		if (fConsistenceCheck == false) qprintf("Generating Char %" PRINTFINT " (Thread: %" PRINTFINT ")\n", i, (longint) (size_t) ((clsThreadData*) data)->handle);
		if (primary && fConsistenceCheck == false && (manual || ChooseClass))
		{
			SetConsoleActiveScreenBuffer(Screens[0]);
		}
		loopcount = 0;
		displayloopcount = 0;
		do
		{
#ifndef VECTORC_RUNTIME
xRestartChar_A:
			try
			{
				CreateChar(&Characters[i]);
			}
			catch(xRestartChar)
			{
				*prepos = reposused;
				saverep("", true);
				Characters[i].CreationTemplate->Reproduce = 1;
				readreproducefinished = 1;
				goto xRestartChar_A;
			}
#else
			CreateChar(&Characters[i]);
#endif
			if (loop)
			{
				for (j = 0;j+5 < loopcount % 9;j++)
				{
					IncreaseCharLevel(&Characters[i], loopcount % 49);
				}
			}

			TPLeft[i + 1] = Characters[i].TPLeft;
			if (loopdisplay)
			{
				if (loop)
				{
					DisplayChar(&Characters[i], i + 1);
				}
			}

			if ((finishreadreproduce && !fConsistenceCheck) || readreproduce)
			{
				if (readreproducefinished == 0)
				{
					fclose(reRead);
				}
				readreproducefinished = 0;
				readreproduce = 0;
				Characters[i].CreationTemplate->Saved = true;
			}

			loopcount++;
			if (loop && primary)
			{
				QueryPerformanceCounter(&full_now);
				full_now.QuadPart = max(1, (__int64) loopcount * qwFreq / (full_now.QuadPart - full_start.QuadPart));
				TotalTime += Characters[i].CreationTime;
				TotalDisplayTime += (__int64) Characters[i].DisplayTime;

				if (loopcount && primary && (loopcount % CONF_DISPLAY_SKIP == 0 || loopcount > displayloopcount + CONF_DISPLAY_SKIP))
				{
					if (loopcount >= displayloopcount + CONF_DISPLAY_SKIP) displayloopcount += CONF_DISPLAY_SKIP;

					printf("%" PRINTFINT " Loop (%" PRINTFINT "/%3" PRINTFINT " usec, %" PRINTFINT " / sec    -    AVG: %" PRINTFINT "/%3" PRINTFINT " usec, %" PRINTFINT " / sec (%" PRINTFINT "))",
						loopcount,
						(longint) Characters[i].CreationTime,
						(longint) Characters[i].DisplayTime,
						(longint) 1000000 / (longint) max(1, Characters[i].CreationTime),
						(longint) (TotalTime / (__int64) loopcount),
						(longint) (TotalDisplayTime / (__int64) loopcount),
						(longint) (1000000 / max(1, TotalTime / (__int64) loopcount)),
						(longint) full_now.QuadPart);
					if (Characters[i].Mixed)
					{
						qprintf(" Dummy: %" PRINTFINT "", (longint) Characters[i].MixedTime);
					}
					qprintf("\n");
				}
				/*if (loopcount > 100 && Characters[i].CreationTime > TotalTime / (__int64) loopcount * (__int64) 25)
				{
					qprintf("\tCreation took unecspected long...\n");
					saverep("long.rep", true, Characters[i].CreationTemplate, 1, 1);
				}*/
				if (BenchmarkMode == 1 && displayloopcount >= 5000)
				{
					TotalTime = TotalDisplayTime = 0;
					QueryPerformanceCounter(&full_start);
					loopcount = displayloopcount = 0;
					BenchmarkMode = 2;
					qprintf("\nCaching Data Finished, Restarting...\n\n");
				}
				else if (BenchmarkMode == 2 && displayloopcount >= 30000)
				{
					forcethreadexit = true;
					qprintf("\n\bBenchmark finished\n\tCPU Type: ");
					printCpuType();
					qprintf("\n\tCPU Features: ");
					printCpuFeatures();
					qprintf("\n\tThreads: %" PRINTFINT "\n\tProgram Version: %" 
						PRINTFINT " (%" PRINTFINT " Bit)\n\tScore: %" PRINTFINT "\n\nPress q to quit or n to restart\n", (longint) dwThreads, buildnr, buildbits, full_now.QuadPart);
					fExit = true;
					retVal = 1;
					loop = 0;

					do
					{
						j = getch();
						j |= 32;	
					}
					while (j != 'n' && j != 'q');
					fExit = !(Restart = (j == 'n'));

					break;
				}
			}
			if (loop && (loopcount & 255) == 0)
			{
				SleepEx(0, false);
			}
			if (!primary && forcethreadexit)
			{
				break;
			}
			if (primary && loop && kbhit())
			{
				j = getch();
				if ((j | 32) == 'l')
				{
					ClearConsole(0);
					loop = 0;
					forcethreadexit = true;
				}
				else if ((j | 32) == 'n')
				{
					loop = 0;
					Restart = 1;
					forcethreadexit = true;
					retVal = 1;
					break;
				}
				else if ((j | 32) == 'r')
				{
					TotalTime = 1;
					TotalDisplayTime = 1;
					QueryPerformanceCounter(&full_start);
					loopcount = 0;
					displayloopcount = 0;
				}
				else if ((j | 32) == 'q')
				{
					forcethreadexit = true;
					fExit = true;
					retVal = 1;
					break;
				}
			}
			if (loop)
			{
				Characters[i].CreationTemplate->Life = -100;
			}
		}
		while (loop);
		loopdisplay = 0;
		if (retVal == 0)
		{
			ClearConsole(i + 1);
			DisplayChar(&Characters[i], i + 1, 0, NULL, data);
			
			if (primary && fConsistenceCheck == false)
			{
				SetConsoleActiveScreenBuffer(Screens[i + 1]);
			}
		}
	}

	if (!primary)
	{
		threadsexited++;
#ifndef GCC_RUNTIME
		_endthreadex((int) retVal);
#endif
	}
	return((unsigned int) retVal);
}

longint run_main()
{
	longint i, j;

	forcethreadexit = false;
	threadsexited = 0;
	clsThreadData* ThreadData = (clsThreadData*) mallocl(dwThreads * sizeof(clsThreadData), "run_main-threaddata");

	ZeroMemory(ThreadData, dwThreads * sizeof(clsThreadData));

	QueryPerformanceCounter(&full_start);

	if (GT.CharCount && threadloop == 0)
	{
		ThreadData[0].start = 0;
		ThreadData[0].end = 1;
		ThreadData[0].primary = true;
		CopyMemory(&Characters[0].Context, &CharContexts[0], sizeof(clsChar::clsCharContext));

		if ((j = run_main_do(&ThreadData[0])) != 0)
		{
			freel(ThreadData);
			return(j);
		}
	}

	if (GT.CharCount > 1 || threadloop)
	{
		i = threadloop ^ 1;
		for (j = 0;j < dwThreads;j++)
		{
			ThreadData[j].start = i;
			i = ((longint) GT.CharCount - (threadloop ^ 1)) * (j + 1) / dwThreads + (threadloop ^ 1);
			i = min(i, (longint) GT.CharCount);
			ThreadData[j].end = i;
			ThreadData[j].primary = (j == 0);
			ThreadData[j].n = j;
		}
		for (j = 0;j < dwThreads;j++)
		{
			for (i = ThreadData[j].start;i < ThreadData[j].end;i++)
			{
				CopyMemory(&Characters[i].Context, &CharContexts[j], sizeof(clsChar::clsCharContext));
			}
			if (j)
			{
#ifdef GCC_RUNTIME
				if ((ThreadData[j].handle = CreateThread(NULL, 0, &run_main_do, (void*) &ThreadData[j], 0, NULL)) == NULL)
				{
					qprintf("Could not Create Thread\n");
					freel(ThreadData);
					forcethreadexit = 1;
					return(-1);
				}
#else
				if ((ThreadData[j].handle = (void*) _beginthreadex(NULL, 0,
#ifdef VECTORC_RUNTIME
					(unsigned int __stdcall (*)(void* data))
#else
					(unsigned int (__stdcall *)(void* data))
#endif
					
					&run_main_do, (void*) &ThreadData[j], 0, NULL)) == NULL)
				{
					qprintf("Could not Create Thread\n");
					forcethreadexit = 1;
					return(-1);
				}
#endif
			}
		}

		j = run_main_do(&ThreadData[0]);

		if (dwThreads > 1)
		{
			qprintf("Waiting for Threads to terminate\n");
		}
		while (threadsexited < dwThreads - 1)
		{
			SleepEx(10, false);
		}

		if (j != 0)
		{
			freel(ThreadData);
			return(j);
		}
	}

	for (i = 0;i < GT.CharCount;i++)
	{
		CopyMemory(&Characters[i].Context, &CharContexts[0], sizeof(clsChar::clsCharContext));
	}

	freel(ThreadData);

	if (GT.CharCount > 1)
	{
		j = 0;
	}
	else
	{
		j = 1;
	}
	if (fConsistenceCheck == false)
	{
		if (GT.CharCount)
		{
			SetConsoleActiveScreenBuffer(Screens[j]);
		}
		DoTable();
	}

	return(j);
}

void run_msgloop(longint j)
{
	longint i, k;

	do
	{
		i = getch();

		if ((i | 32) == 'a')
		{
			j = max(0, j - 1);
		}
	
		if ((i | 32) == 'd')
		{
			j = min((longint) GT.CharCount, j + 1);
		}

		if ((i | 32) == 'w')
		{
			j = (longint) GT.CharCount;
		}

		if ((i | 32) == 's')
		{
			j = 0;
		}

		if (i >= '0' && i < min('9', '0' + GT.CharCount))
		{
			j = i - '0';
		}

		if (GT.CharCount)
		{
			if ((i | 32) == 'x')
			{
				char FileName[270] = "export\\";
				FILE* pExportFile;

				ClearConsole(0);
				SetConsoleActiveScreenBuffer(Screens[0]);
				
				qprintf("Enter Export Filename! ");

				getFileName(FileName + strlen(FileName), ".exp");
				pExportFile = fopen(FileName, "w+");
				if (pExportFile == NULL)
				{
					qprintf("Coult not oepn export file!\n");
				}
				else
				{
					SetConsoleActiveScreenBuffer(Screens[0]);

					if (j == 0)
					{
						for (k = 0;k < GT.CharCount;k++)
						{
							DisplayChar(&Characters[k], k + 1, 1, pExportFile);
						}
					}
					else
					{
							DisplayChar(&Characters[j - 1], j, 1, pExportFile);
					}
					fclose(pExportFile);
				}

				DoTable();
				SetConsoleActiveScreenBuffer(Screens[j]);
			}

			if ((i | 32) == 'e')
			{
				if (manual == 0 && ChooseClass == 0)
				{
					ChooseClass = 1;
				}
				else if (ChooseClass == 1 && manual == 0)
				{
					manual = 1;
				}
				else
				{
					ChooseClass = manual = 0;
				}
				if (UseIsaac && ChooseClass)
				{
					UseIsaac = false;
				}
				RandomText = ChooseClass || manual || qon_DebugOutput || logverbose;
				reproduce = ChooseClass || manual || !UseIsaac;
				manual2 = manual;
				setverbose();
				COORD cBuffer;
				cBuffer.X = 40;
				cBuffer.Y = (short) TPPos[j];
				SetConsoleCursorPosition(Screens[j], cBuffer);
				sprintf(tempoutcommon, "Manual mode set to: %" PRINTFINT "\n", (longint) (manual == 1 ? 2 : ChooseClass));
				WriteConsole(Screens[j], tempoutcommon, (unsigned int) strlen(tempoutcommon), (unsigned long*) &k, NULL);
			}

			if ((i | 32) == 'r')
			{
				if (j == 0)
				{
					ClearConsole(0);
					if (manual || ChooseClass) SetConsoleActiveScreenBuffer(Screens[0]);
					for (k = 0;k < GT.CharCount;k++)
					{
						ClearConsole(k + 1);
						SetConsoleActiveScreenBuffer(Screens[0]);
						Characters[k].CreationTemplate->Life = -100;
						CreateChar(&Characters[k]);
						TPLeft[k + 1] = Characters[k].TPLeft;
						DisplayChar(&Characters[k], k + 1);
						SetConsoleActiveScreenBuffer(Screens[k + 1]);
					}
					SetConsoleActiveScreenBuffer(Screens[0]);
				}
				else
				{
					ClearConsole(0);
					SetConsoleActiveScreenBuffer(Screens[0]);
					ClearConsole(j);
					Characters[j - 1].CreationTemplate->Life = -100;
					CreateChar(&Characters[j - 1]);
					TPLeft[j] = Characters[j - 1].TPLeft;
					DisplayChar(&Characters[j - 1], j);
					SetConsoleActiveScreenBuffer(Screens[j]);
				}
				DoTable();
			}

			if ((i | 32) == 'c')
			{
				if (j != 0 && Characters[j - 1].Level - Characters[j - 1].MonsterLevel < 50)
				{
					ClearConsole(0);
					SetConsoleActiveScreenBuffer(Screens[0]);

					while (kbhit()) getch();
					fflush(stdin);
					qprintf("Wie viele Stufen hinzufgen? (1 - %" PRINTFINT ")", 50 - Characters[j - 1].Level + Characters[j - 1].MonsterLevel);
					do
					{
						scanf("%" PRINTFINT "", &k);
					} while (k < 1 || k > 50 - Characters[j - 1].Level + Characters[j - 1].MonsterLevel);

					IncreaseCharLevel(&Characters[j - 1], k);
					DoFinalVals(&Characters[j - 1], false);
					ClearConsole(j);
					DisplayChar(&Characters[j - 1], j);
					SetConsoleActiveScreenBuffer(Screens[j]);
					DoTable();
					SetConsole(j, 0);
				}
			}

			if (i == '+' || i == '-' || i == '*')
			{
				if (j != 0)
				{
					longint OldLife;
					OldLife = Characters[j - 1].FinalLife;
					ClearConsole(0);
					ClearConsole(j);
					ChangeChar(&Characters[j - 1], i);
					DoFinalVals(&Characters[j - 1], false);
					DisplayChar(&Characters[j - 1], j);
					DoTable();
					TPLeft[j] += Characters[j - 1].FinalLife - OldLife;
					DoConsoleTP(j);
					SetConsole(j, 0);
				}
			}

			if ((i | 32) == 'v')
			{
				char savename[257];

				ClearConsole(0);
				SetConsoleActiveScreenBuffer(Screens[0]);
				
				qprintf("Dateinamen zum speichern angeben! ");

				getFileName(savename, ".rep");

				saverep(savename, true, (j == 0 ? Characters[0].CreationTemplate : Characters[j - 1].CreationTemplate), (j == 0 ? (longint) GT.CharCount : 1));
				DoTable();
				SetConsoleActiveScreenBuffer(Screens[j]);
			}

			if ((i | 32) == 't' && j != 0)
			{
				ChangeTP(j);
				DoConsoleTP(j);
			}
		}

		if ((i | 32) == 'n')
		{
			Restart = true;
			i = 'q';
			j = 0;
			ClearConsole(0);
		}
		SetConsoleActiveScreenBuffer(Screens[j]);
	} while ((i | 32) != 'q');
}

longint run()
{
	longint i, retVal;
	LARGE_INTEGER randinit;

	prepos = (unsigned longint*) &CTtmp.re.repos;
	retemp = (unsigned longint*) &CTtmp.re.retemp[0];
	*prepos = 0;

	QueryPerformanceCounter(&randinit);
	i = randinit.LowPart;
	srand((int) i);

	manual2 = manual;

	retVal = run_init();
	if (retVal)
	{
		if (retVal == -1)
		{
			goto AskRestart;
		}
		return(1);
	}

	CreateCharContext();

	retVal = run_worktype();
	if (retVal == -1)
	{

AskRestart:
		qprintf("[N] Zurck ins Hauptmen\n[Q] Beenden\n");
		while(kbhit()){getch();}
		do
		{
			i = getch();

			if ((i | 32) == 'n')
			{
				Restart = true;
				i = 'q';
				if (worktype != 2 && worktype != 1)
				{
					ClearConsole(-1);
				}
			}
		}
		while ((i | 32) != 'q');

		return(0);
	}
	else if (retVal)
	{
		return(1);
	}

	IsaacInitDone = false;

	if (reproduce == 2)
	{
		if (run_reproduce())
		{
			run_cleanup(0, 0);
			Restart = 1;
			return(0);
		}
	}
	else if (run_templates())
	{
		return(1);
	}
	else if (ChooseClass == 0 && manual == 0 && manual2 == 0 && readreproduce == 0)
	{
		isaacinitrand();
		IsaacInitDone = true;
	}

	if (run_screenbuffer())
	{
		run_cleanup(0);
		return(1);
	}

	InitPassed = 1;

	retVal = run_main();

	if (!fExit && !Restart && retVal != -1 && fConsistenceCheck == false)
	{
		run_msgloop(retVal);
	}

	run_cleanup();

	return(0);
}
