template <class T> inline longint GetSourceNumber(T* Source, longint Count, const char* Name, longint uncomplete = 0, longint raiseerror = 1)
{
	longint i;
	for (i = 0;i < Count;i++)
	{
		if (Source[i].Name == Name || (uncomplete && strstr(Source[i].Name, Name)))
		{
			return(i);
		}
	}
	if (raiseerror)
	{
		qprintf("Not found: %s\n", Name);
		quitprog();
		return(0);
	}
	else
	{
		return(-1);
	}
}

longint GetCharNumber(const char* CharName)
{
	return(GetSourceNumber<clsCharSource>(Source.CharSource, Source.CharSourceCount, CharName));
}

longint GetDomainNumber(const char* DomainName)
{
	return(GetSourceNumber<clsDomainSource>(Source.DomainSource, Source.DomainSourceCount, DomainName));
}

longint GetEffectNumber(const char* EffectName)
{
	return(GetSourceNumber<clsEffectSource>(Source.EffectSource, Source.EffectSourceCount, EffectName));
}

longint GetEquipNumber(const char* EquipName)
{
	return(GetSourceNumber<clsEquipSource>(Source.EquipSource, Source.EquipSourceCount, EquipName));
}

longint GetFeatNumber(const char* FeatName, longint uncomplete)
{
	return(GetSourceNumber<clsFeatSource>(Source.FeatSource, Source.FeatSourceCount, FeatName, uncomplete));
}

longint GetMonsterNumber(const char* MonsterName)
{
	return(GetSourceNumber<clsMonsterSource>(Source.MonsterSource, Source.MonsterSourceCount, MonsterName));
}

longint GetMonsterTypeNumber(const char* MonsterTypeName)
{
	return(GetSourceNumber<clsMonsterTypeSource>(Source.MonsterTypeSource, Source.MonsterTypeSourceCount, MonsterTypeName, 1));
}

longint GetPowerNumber(const char* PowerName)
{
	return(GetSourceNumber<clsPowerSource>(Source.PowerSource, Source.PowerSourceCount, PowerName));
}

longint GetRaceNumber(const char* RaceName)
{
	return(GetSourceNumber<clsRaceSource>(Source.RaceSource, Source.RaceSourceCount, RaceName));
}

longint GetRegionNumber(const char* RegionName)
{
	return(GetSourceNumber<clsRegionSource>(Source.RegionSource, Source.RegionSourceCount, RegionName));
}

longint GetSchoolNumber(const char* SchoolName)
{
	return(GetSourceNumber<clsSchoolSource>(Source.SchoolSource, Source.SchoolSourceCount, SchoolName));
}

longint GetSizeNumber(const char* SizeName)
{
	return(GetSourceNumber<clsSizeSource>(Source.SizeSource, Source.SizeSourceCount, SizeName, 1));
}

longint GetSkillNumber(const char* SkillName, longint uncomplete)
{
	return(GetSourceNumber<clsSkillSource>(Source.SkillSource, Source.SkillSourceCount, SkillName, uncomplete));
}

longint GetSpellNumber(const char* SpellName)
{
	return(GetSourceNumber<clsSpellSource>(Source.SpellSource, Source.SpellSourceCount, SpellName));
}

longint GetSpecialNumber(const char* SpecialName, longint type = -1)
{
	longint i;
	for (i = 0;i < Source.SpecialSourceCount;i++)
	{
		if ((type == -1 || type == Source.SpecialSource[i].Type) && Source.SpecialSource[i].Name == SpecialName)
		{
			return(i);
		}
	}
	qprintf("Special not found(%s)\n", SpecialName);
	quitprog();
	return(0);
}

longint GetTemplateNumber(const char* TemplateName)
{
	return(GetSourceNumber<clsTemplateSource>(Source.TemplateSource, Source.TemplateSourceCount, TemplateName));
}

longint GetBonusNumber(const char* BonusName)
{
	return(GetSourceNumber<clsBonusSource>(Source.BonusSource, Source.BonusSourceCount, BonusName));
}

longint GetAbbilityNumber(const char* AbbilityName)
{
	return(GetSourceNumber<clsAbbilitySource>(Source.AbbilitySource, Source.AbbilitySourceCount, AbbilityName));
}
