#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <winbase.h>

#include "defines.h"
#include "qon/include.h"
#include "global.h"
#include "include/cpuid.h"

//Exports
#ifdef STRING_KEEP_ALLOC_LOG
longint stringKeepAllocTry = 0;
longint stringKeepAllocWorked = 0;
#endif

extern "C" clsSource Source;
extern "C" clsTempSource TempSource;
clsSource Source;

extern "C" clsGrammar ScriptGrammar;
clsGrammar ScriptGrammar;

#ifdef INCLUDE_REBUILD
clsTempSource TempSource;
#endif

extern "C" CharTemplate CTtmp;
extern "C" clsChar cDumpChar;
extern "C" clsEquip eDumpEquip;
CharTemplate CTtmp;
clsChar cDumpChar;
clsEquip eDumpEquip;

longint manualverbose = -1, manuallogverbose = -1;

bool fNoAutoSave = false;

longint BenchmarkMode;
longint dwThreads;
longint dwNumProcessors;
bool fUserThreads = false;

longint Moneys[MAX_CHARS];
longint TPPos[MAX_CHARS + 1];
longint TPLeft[MAX_CHARS + 1];

char refname[SMALL_BUFFER_LEN]; 

longint MustRebuild;
longint Rebuilded = 0;

const longint buildnr =
#include "buildnr"
;
const longint buildbits = 8 * sizeof(size_t);

unsigned longint dwMemAccessCount = 0;
longint dwMemAccessMax = 0;

longint TestScript = 0;

extern "C" CharTemplate ReHeaderSave;
extern "C" CharTemplate reheader;
bool UseReHeaderSave = false;
CharTemplate ReHeaderSave, reheader;

bool fConsistenceCheck = false;
bool fConsistenceClean = false;
extern "C" basestring* strConsistenceCheck;
basestring* strConsistenceCheck;
char* pConsistenceSave;

bool fDropMsg = false;

longint useagain[USE_AGAIN];
longint useagainaddr[USE_AGAIN];

__int64 qwFreq;

longint AllocOutput = 0;

longint CompactSourceAllocated = 0;

char tempoutcommon[BUFFER_LEN];

unsigned long** isaacseeds = NULL;
unsigned long* isaacseeddata = NULL;

extern "C" void* mallocLogATemp;
void* mallocLogATemp;

#ifdef BUILD_VS_NET
	namespace vcnetspace
	{
		extern longint __cdecl dndmain(longint argc, char** argv);
	}
#endif

#ifdef BUILD_DEBUG
	namespace debugspace
	{
		extern longint __cdecl dndmain(longint argc, char** argv);
	}
#endif

#ifdef BUILD_INTEL
	namespace intelspace
	{
		extern longint __cdecl dndmain(longint argc, char** argv);
	}
#endif

#ifdef BUILD_VECTORC
	namespace vectorcspace
	{
		extern longint __cdecl dndmain(longint argc, char** argv);
	}
#endif

#ifdef BUILD_GCC
	extern "C" void __stdcall _Z14if_gcc_dndmaini(longint dump);
#endif

#ifdef buildbcc
	namespace bccspace
	{
		extern longint __cdecl dndmain(longint argc, char** argv);
	}
#endif

longint Runtime(longint Num, longint argc, char** argv)
{
	longint Start = Num;
	longint restarted = 0;

	goto skiprestart;

restart:
	restarted = 1;
	Num++;
	Num %= 5;

	if (Num == Start)
	{
		qprintf("No suitable Runtime found\n");
		getchar();
		return(1);
	}

skiprestart:

	if (Num == RUNTIME_DEBUG)
	{
#ifdef BUILD_DEBUG
		if (fConsistenceCheck == false)
		{
			qprintf("\nRunning Debug Code\n");
		}
		return(debugspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			qprintf("Debug Runtime not included, Trying another\n");
			goto restart;
		}
		return(1);
#endif
	}

	if (Num == RUNTIME_INTEL)
	{
#ifdef BUILD_INTEL
		if (fConsistenceCheck == false)
		{
			qprintf("\nRunning Intel Compiler Conroe Optimized Code requiring SSSE3\n");
		}
		if (HasSSSE3() == false)
		{
			qprintf("WARNING, NO SSSE3 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(intelspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			qprintf("Intel Compiler Runtime not included, Trying another\n");
			goto restart;
		}
		return(1);
#endif
	}

	if (Num == RUNTIME_VECTORC)
	{
#ifdef BUILD_VECTORC
		if (fConsistenceCheck == false)
		{
			qprintf("\nRunning VectorC Compiler Optimized Code requiring SSE2\n");
		}
		if (HasSSE2() == false)
		{
			qprintf("WARNING, NO SSE2 Capable FOUND\n");
			if (restarted)
			{
				goto restart;
			}
		}
		return(vectorcspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			qprintf("VectorC Runtime not included, Trying another\n");
			goto restart;
		}
		return(1);
#endif
	}

	if (Num == RUNTIME_GCC)
	{
#ifdef BUILD_GCC
		if (fConsistenceCheck == false)
		{
			qprintf("\nRunning GCC Compiler Opteron Optimized Code requiring SSE3\n");
		}
		if (HasSSE3() == false)
		{
			qprintf("WARNING, NO SSE3 Capable CPU Found\n");
			if (restarted)
			{
				goto restart;
			}
		}
		_Z14if_gcc_dndmaini(0);
		return(0);
#else
		if (fConsistenceCheck == false)
		{
			qprintf("GCC Runtime not included, Trying another\n");
			goto restart;
		}
		return(1);
#endif
	}

	if (Num == RUNTIME_VS)
	{
#ifdef BUILD_VS_NET
		if (fConsistenceCheck == false)
		{
			qprintf("Running Visual C++ .NET Compiler Optimized Code\n");
		}
		return(vcnetspace::dndmain(argc, argv));
#else
		if (fConsistenceCheck == false)
		{
			qprintf("Visual C++ .NET Runtime not included, Trying another\n");
			goto restart;
		}
		return(1);
#endif
	}

	qprintf("Unknown Runtime\nExiting...\n");
	getchar();
	return(1);
}

longint CheckSaveDir(const char* dirname)
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;

	hFindFile = FindFirstFile(dirname, &FindData);

	if (hFindFile != INVALID_HANDLE_VALUE)
	{
		FindClose(hFindFile);
		if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		{
			return(0);
		}
	}

	return(!CreateDirectory(dirname, NULL));
}

#ifdef DUMP_SOURCE_LOAD
bool MustUnReAlloc = false;

void UnReAlloc()
{
	if (MustUnReAlloc)
	{
		MustUnReAlloc = false;
		freel(ScriptGrammar.pSymbolNames);
	}
}
#endif

#ifdef ALLOW_FLOAT_TEST
namespace debugspace {double __cdecl CheckFloat(double val);}
namespace intelspace {double __cdecl CheckFloat(double val);}
namespace vectorcspace {double __cdecl CheckFloat(double val);}
namespace gccspace {extern "C" double __cdecl if_gcc_CheckFloat(double val);}
namespace vcnetspace {double __cdecl CheckFloat(double val);}

#include "include/float.h"
longint CheckFloatConsistence()
{
#if (ALLOW_FLOAT_TEST == 2)
	qprintf("Checking Float Consistence\n");
#endif
	double valdebug, valintel, valvectorc, valgcc, valvcnet, valstd;

	valstd = CheckFloat(10);

#ifdef BUILD_DEBUG
	valdebug = debugspace::CheckFloat(10);
#else
	valdebug = valstd;
#endif

	if (HasSSE3())
	{
#ifdef BUILD_INTEL
		valintel = intelspace::CheckFloat(10);
#else
		valintel = valstd;
#endif

#ifdef BUILD_GCC
		valgcc = gccspace::if_gcc_CheckFloat(10);
#else
		valgcc = valstd;
#endif
	}
	else
	{
		qprintf("Skipping Intel Compiler and GCC as not SSE3 support was found\n");
		valintel = valdebug;
		valgcc = valdebug;
	}

	if (HasSSE2())
	{
#ifdef BUILD_VECTORC
		valvectorc = vectorcspace::CheckFloat(10);
#else
		valvectorc = valstd;
#endif
	}
	else
	{
		qprintf("Skipping VectorC as no SSE2 Support was found\n");
		valvectorc = valdebug;
	}
#ifdef BUILD_VS_NET
	valvcnet = vcnetspace::CheckFloat(10);
#else
	valvcnet = valstd;
#endif

	if (valdebug != valintel || valdebug != valvectorc || valdebug != valgcc || valdebug != valvcnet || valdebug != valstd)
	{
		qprintf("Float not consistent between Compilers !!!\n");
		qprintf("Reproduce might not work correctly !!!\n");
		qprintf("Press a key to continue\n");
		fflush(stdin);
		getch();
	}
#if (ALLOW_FLOAT_TEST == 2)
	else
	{
		qprintf("Float consistent\n");
	}
#endif

	return(0);
}
#endif

int main(longint argc, char** argv)
{
	longint StdRun = RUNTIME_DEBUG;
	longint RetVal, RetVal2 = 0;

	SYSTEM_INFO SystemInfo;

	SYSTEM_INFO sSysInfo;
	GetSystemInfo(&sSysInfo);
	dwPageSize = sSysInfo.dwPageSize;

	qprintf("DND Chargen V. 1.4.2 (Build %" PRINTFINT " / %" PRINTFINT " Bit Version) Coded by qon in 2k7\n\n", (longint) buildnr, buildbits);

#ifdef ALLOW_FLOAT_TEST
	CheckFloatConsistence();
#endif

	if (CheckSaveDir("save") || CheckSaveDir("export"))
	{
		qprintf("Cannot Create Save Directory\n");
		RetVal = 1;
		goto mainend;
	}
	QueryPerformanceFrequency((LARGE_INTEGER*) &qwFreq);

	GetSystemInfo(&SystemInfo);
	qprintf("Detected %" PRINTFINT " Processors\n", (longint) SystemInfo.dwNumberOfProcessors);
	dwThreads = dwNumProcessors = SystemInfo.dwNumberOfProcessors;

#ifdef DUMP_SOURCE_LOAD
	if (MustRebuild = ReAlloc(SOURCE_FILE, &Source, sizeof(clsSource), &ScriptGrammar.pSymbolNames, (longint) 0))
	{
		qprintf("will rebuild later...\n\n");
	}
	else
	{
		MustUnReAlloc = true;
	}
#else
	MustRebuild = 1;
#endif

#ifndef INCLUDE_REBUILD
	if (MustRebuild)
	{
		RetVal = 1;
		goto mainend;
	}
#endif

	if (argc == 2)
	{
		StdRun = atoi(argv[1]);
		qprintf("Runtime choosen by Argument\n");
	}
#ifdef BUILD_INTEL
	else if (HasSSSE3())
	{
		qprintf("SSSE3 capable CPU found, using Intel Compiler Runtime\n\n");
		StdRun = RUNTIME_INTEL;
	}
#endif
#ifdef BUILD_GCC
	else if (HasSSE3())
	{
		qprintf("SSE3 capable CPU found, using GCC Runtime\n\n");
		StdRun = RUNTIME_GCC;
	}
#endif
#ifdef BUILD_VSNET
	else if (HasSSE2())
	{
		qprintf("No SSE3 capable CPU found, using Microsoft Compiler Generic Runtime\n\n");
		StdRun = RUNTIME_VS;
	}
#endif
#ifdef BUILD_DEBUG
	else
	{
		qprintf("No optimized runtime with apropriate CPU extensions found, running Debug Runtime\n\n");
		StdRun = RUNTIME_DEBUG;
	}
#endif

	RetVal = Runtime(StdRun, argc, argv);

	if ((CompactSourceAllocated && (!VirtualFree((void*) VIRTUAL_COMPACT_BASE, 0, MEM_RELEASE))) || RetVal2)
	{
		qprintf("Failed freeing Memory for some reason, Shouldn't make a difference yet though :|\n\n");
		RetVal = 1;
	}

	ZeroMemory(&Source, sizeof(clsSource));

#ifdef DUMP_SOURCE_LOAD
	UnReAlloc();
#endif

#ifdef MALLOC_LOG
	if (ListAlloc() == -1) RetVal = -1;
#endif

#ifdef STRING_KEEP_ALLOC_LOG
	qprintf("String Optimization Result: %" PRINTFINT " of %" PRINTFINT " reallocations avoided\nPress a key to continue\n", stringKeepAllocWorked, stringKeepAllocTry);
	fflush(stdin);
	getchar();
#endif

mainend:
	while (kbhit()) {getch();}
	fflush(stdin);
	if (RetVal)
	{
		qprintf("Aborting...\n");
		getch();
	}
	else
	{
		qprintf("\nExiting...\n");
	}
	if (fDebugFile != stdout) fclose((FILE*) fDebugFile);
	return((int) RetVal);
}

longint __cdecl breakpoint(char* Text)
{
	qprintf("Breakpoint: %s\n", Text);
	throw(Text);
	return(0);
}