#ifdef QON_INCLUDE_BNF

extern char* DoRule(char* CodePos, char* Symbol, longint tCompressed, clsGrammar* pGrammar, char* tSymbolName = NULL, bool bnot = false);
extern char* pInitSymbol;

extern "C" char* pTree;
extern size_t nTreeSize;
extern "C" size_t nTreeSizeMax;
extern char* SourceBuffer;
extern size_t SourceFileSize;

#include "../script/scriptopt.h"

void bnflist(clsGrammar* pGrammar, char* pScript, size_t scriptsize, bool optimized)
{
	ListBNF(pGrammar, pScript, scriptsize, optimized);
}

longint bnfinit(char* configfile, clsGrammar* pGrammar)
{
	qprinta(2)("Reading Config\n");
	if (ReadConfig(configfile, pGrammar))
	{
		qprintf("Error Reading Config File\n");
		return(1);
	}

	if (InitGrammar(pGrammar, configfile))
	{
		qprintf("Error Initializing Grammar\n");
		return(1);
	}

	qprinta(2)("\n\n");
	return(0);
}

longint bnfparse(char* Source, char** ppTree, clsGrammar* pGrammar)
{
	qprinta(2)("\nSplitting Script\n");

	SourceBuffer = Source;
	SourceFileSize = strlen(Source);

	if (SplitBuffer(pGrammar, Source))
	{
		return(1);
	}

	if ((*ppTree = (char*) mallocl(nTreeSize, "bnfparse-ppTree")) == 0)
	{
		qprintf("Memmory Allocaiton Error\n");
		return(1);
	}

	CopyMemory(*ppTree, pTree, nTreeSize);

	bnfreset();

	return(0);
}

void bnfreset()
{
	nTreeSizeMax = 0;
	nTreeSize = 0;
}

longint bnfexit(clsGrammar* pGrammar)
{
	if (ExitGrammar(pGrammar))
	{
		qprintf("Error Unloading Grammar\n");
		getchar();
		return(1);
	}

	freel(pGrammar->SymbolPointer);
	freel(pGrammar->lpSeperatorBytes);
	freel(pGrammar->lpComments);
	freel(pGrammar->pSymbolNames);

	return(0);
}

#endif
