#ifdef QON_INCLUDE_BNF

#ifdef GCC_RUNTIME
#include <stdio.h>
#endif

extern char* pInitSymbol;

char* SourceBuffer;
size_t SourceFileSize;

longint Space = 0;

char StrOutBuffer[65];

extern "C" char* pTree;
char* pTree;
size_t nTreeSize = 0;
extern "C" size_t nTreeSizeMax;
size_t nTreeSizeMax = 0;

size_t nTreeSizeMax2;

char AddChar[2] = " ";

size_t AddInt;

char* ErrorBestPos;

void AddTree(char* val, size_t vallen = 0)
{
	char* pOldTree;

	if (vallen == 0)
	{
		vallen = strlen(val);
	}

	if (nTreeSize + vallen >= nTreeSizeMax)
	{
		nTreeSizeMax += SMALL_BUFFER_LEN;
		nTreeSizeMax2 = max(nTreeSizeMax2, nTreeSizeMax);
		pOldTree = pTree;
		pTree = (char*) mallocl(nTreeSizeMax, "AddTree-pTree");
		pTree[0] = 0;
		if (nTreeSize)
		{
			CopyMemory(pTree, pOldTree, nTreeSize + 1);
		}
		if (pOldTree)
		{
			freel(pOldTree);
		}
	}

	CopyMemory(pTree + nTreeSize, val, vallen);
	nTreeSize += vallen;
}

void TreeSub(longint SymbolID, char** SymbolPointer)
{
	AddChar[0] = 1;
	AddTree(AddChar, 1);
	AddInt = (size_t) SymbolPointer[SymbolID];
	AddTree((char*) &AddInt, sizeof(size_t));
}

void TreeReturn()
{
	AddChar[0] = 0;
	AddTree(AddChar, 1);
}

template <class T>longint FindMemory(T* start, T val)
{
	longint i = 1;
	while (*start)
	{
		if (*start++ == val)
		{
			return(i);
		}
		i++;
	}
	return(0);
}

void PrintFoundLine(char* SymbolStartPos, char* SymbolEndPos)
{
	char* pTemp;
	char* oBuffer;

	while (*SymbolEndPos == 13 || *SymbolEndPos == 10)
	{
		SymbolEndPos--;
	}
	
	for (pTemp = SymbolEndPos;pTemp >= SymbolStartPos;pTemp--)
	{
		if (*pTemp == 10 || *pTemp == 13)
		{
			break;
		}
	}

	if (!(oBuffer = (char*) mallocl(SymbolEndPos - pTemp + 1, "PrintFoundLine-oBuffer")))
	{
		qprintf("Memory Allocation Error\n");
		getchar();
		exit(1);
	}

	CopyMemory(oBuffer, pTemp + 1, SymbolEndPos - pTemp);
	oBuffer[SymbolEndPos - pTemp - 1] = 0;
	qprintf("\"%s\"", oBuffer);
	freel(oBuffer);
}

char* DoRule(char* CodePos, char* Symbol, longint tCompressed, clsGrammar* pGrammar, char* tSymbolName, bool bnot)
{
	char *pRuleGrammar = Symbol, *pCode = CodePos, *pRet, *pTemp, *pTempAll = CodePos;
	char *pNot, *pNotTemp;
	longint Compressed;

	char* SymbolName;
	longint SymbolID;

	char* SeperatorStartPos = CodePos;
	char* SymbolStartPos = CodePos;

	longint i;
	longint CheckForComment;
	char* pComment;
	longint CheckForSeperator;

	bool SyntaxCorrect;
	bool DontSkip;

	size_t nTreeInitSize = nTreeSize;
	size_t nTreeNotTemp;
	
	char prSpace[16];

	if (pCode > ErrorBestPos)
	{
		ErrorBestPos = pCode;
	}

	Space++;
	sprintf(prSpace, "%%%" PRINTFINT "s", Space * 2);

	if (bnot)
	{
		Compressed = tCompressed;
		if (!(SymbolName = (char*) mallocl(strlen(tSymbolName) + 5, "DoRule-SymbolName")))
		{
			qprintf("Memory Allocation Error\n");
			getchar();
			exit(1);
		}
		sprintf(SymbolName, "%s NOT", tSymbolName);
	}
	else
	{
		Compressed = *((longint*) pRuleGrammar) | tCompressed;
		pRuleGrammar += sizeof(longint);
		SymbolID = *((longint*) pRuleGrammar);
		pRuleGrammar += sizeof(longint);

		if (!(SymbolName = (char*) mallocl(strlen(pRuleGrammar) + 1, "DoRule-SymbolName2")))
		{
			qprintf("Memory Allocation Error\n");
			return(0);
		}
		strcpy(SymbolName, pRuleGrammar);
		pRuleGrammar += strlen(pRuleGrammar) + 1;
	}

	if (!tCompressed)
	{
		qprinta(DEBUG_BNF_SPLIT)(prSpace, "");
		qprinta(DEBUG_BNF_SPLIT)("%10d %s\n", ((longint) (pCode - SourceBuffer)), SymbolName);
	}

	pNot = pCode;

	if (!tCompressed)
	{
		TreeSub(SymbolID, pGrammar->SymbolPointer);
	}

	while (*pRuleGrammar)
	{
		if (pCode >= SourceBuffer + SourceFileSize && pCode == 0)
		{
			return(0);
		}
		SyntaxCorrect = false;
		if (Compressed == 0)
		{
			CheckForComment = 1;

			while (CheckForComment)
			{
				CheckForComment = 0;

				do
				{
					CheckForSeperator = 0;
					for (i = 0;i < pGrammar->nSeperatorCount;i++)
					{
						if (*pCode == pGrammar->lpSeperatorBytes[i])
						{
							pCode++;
							CheckForSeperator = 1;
							break;
						}
					}
				} while (CheckForSeperator);

				pComment = pGrammar->lpComments;

				while (*pComment)
				{
					if (strncmp(pCode, pComment, strlen(pComment)) == 0)
					{
						pComment += strlen(pComment) + 1;
						CheckForComment = 1;

						while (strncmp(pCode++ - strlen(pComment) + 1, pComment, strlen(pComment)) != 0) {}
					}
					else
					{
						pComment += strlen(pComment) + 1;
					}
					pComment += strlen(pComment) + 1;
				}
			}
		}

		if (*((longint*) pRuleGrammar) == G_LINK)
		{
			if ((char*) *((size_t*) (pRuleGrammar + sizeof(longint))))
			{
				pRet = DoRule(pCode, (char*) *((size_t*) (pRuleGrammar + sizeof(longint))), Compressed, pGrammar);
				SyntaxCorrect = (pRet > 0);
				if (pRet) {pCode = pRet;}
			}
			else
			{
				if (*pCode == '_')
				{
					AddTree(" ", 1);
				}
				else
				{
					AddTree(pCode, 1);
				}
				pCode++;
				SyntaxCorrect = true;
			}
			pRuleGrammar += 2 * sizeof(longint);
		}
		else if (*((longint*) pRuleGrammar) == G_GROUP)
		{
			pRet = DoRule(pCode, (char*) *((size_t*) (pRuleGrammar + sizeof(longint))), Compressed, pGrammar);
			if (pRet) {pCode = pRet;}

			SyntaxCorrect = (pRet > 0);

			pRuleGrammar += 2 * sizeof(longint);
		}
		else if (*((longint*) pRuleGrammar) == G_OPT)
		{
			pRet = DoRule(pCode, (char*) *((size_t*) (pRuleGrammar + sizeof(longint))), Compressed, pGrammar);
			if (pRet)
			{
				pCode = pRet;
			}
			pRuleGrammar += 2 * sizeof(longint);
			SyntaxCorrect = true;
		}
		else if (*((longint*) pRuleGrammar) == G_REP)
		{
			do
			{
				pTemp = pCode;
				pRet = DoRule(pCode, (char*) *((size_t*) (pRuleGrammar + sizeof(longint))), Compressed, pGrammar);
				if (pRet) {pCode = pRet;}
			} while (pRet && pRet != pTemp);
			pRuleGrammar += 2 * sizeof(longint);
			SyntaxCorrect = true;
		}
		else if (*((longint*) pRuleGrammar) == G_STRING)
		{
			SyntaxCorrect = true;
			i = min(*((longint*) (pRuleGrammar + sizeof(longint))), 64);
			CopyMemory(StrOutBuffer, (void*) (pRuleGrammar + 2 * sizeof(longint)), i);
			StrOutBuffer[i] = 0;
			
			for (i = 0;i < (*((longint*) (pRuleGrammar + sizeof(longint))));i++)
			{
				if (!pGrammar->CaseSensitive ? ucase(*(pRuleGrammar + 2 * sizeof(longint) + i)) != ucase(*(pCode + i)) : *(pRuleGrammar + 2 * sizeof(longint) + i) != *(pCode + i))
				{
					SyntaxCorrect = false;
					break;
				}
			}
			if (SyntaxCorrect)
			{
				pCode += *((longint*) (pRuleGrammar + sizeof(longint)));
				if (!tCompressed)
				{
					qprinta(DEBUG_BNF_SPLIT)(prSpace, "");
					qprinta(DEBUG_BNF_SPLIT)("%5s%10" PRINTFINT " FOUND \"%s\"\n", "", (longint) (size_t) (pCode - SourceBuffer), StrOutBuffer);
				}
				AddTree(StrOutBuffer);
			}
			pRuleGrammar += *((longint*) (pRuleGrammar + sizeof(longint))) + 2 * sizeof(longint);
		}
		else if (*((longint*) pRuleGrammar) == G_NOT)
		{
			pRuleGrammar += sizeof(longint);

			pNotTemp = pCode;
			pCode = pNot;

			nTreeNotTemp = nTreeSize;
			pTemp = DoRule(pCode, pRuleGrammar, Compressed, pGrammar, SymbolName, true);
			nTreeSize = nTreeNotTemp;
			pTree[nTreeSize] = 0;
			SyntaxCorrect = (pTemp != pNotTemp);
			pRuleGrammar = SkipRule(pRuleGrammar);

			if (SyntaxCorrect) {pCode = pNotTemp;}
		}
		else if (*((longint*) pRuleGrammar) == G_SEP)
		{
			pRuleGrammar += sizeof(longint);
			pNot = pCode;
			SyntaxCorrect = true;
			SeperatorStartPos = pCode;
		}
		else if (*((longint*) pRuleGrammar) == G_OR)
		{
			pRuleGrammar += sizeof(longint);
			if (!DontSkip)
			{
				pRuleGrammar = SkipRule(pRuleGrammar);
			}
			SyntaxCorrect = true;
		}
		else if (*((longint*) pRuleGrammar) == G_END)
		{
			goto EndFound;
		}
		else
		{
			qprintf("Internal Error\n");
			getchar();
			exit(1);
		}
		DontSkip = false;
		if (!SyntaxCorrect)
		{
			if (!(*((longint*) pRuleGrammar) == G_OR))
			{
				if (!tCompressed)
				{
					qprinta(DEBUG_BNF_SPLIT)(prSpace, "");
					qprinta(DEBUG_BNF_SPLIT)("%10" PRINTFINT " FAILED %s\n", (longint) (pCode - SourceBuffer), SymbolName);
				}

				nTreeSize = nTreeInitSize;
				pTree[nTreeSize] = 0;

				Space--;
				freel(SymbolName);
				return(0);
			}
			DontSkip = true;
		}
	}
EndFound:
	if (!tCompressed)
	{
		qprinta(DEBUG_BNF_SPLIT)(prSpace, "");
		if (pCode != pTempAll)
		{
			qprinta(DEBUG_BNF_SPLIT)("%10" PRINTFINT " FOUND %s:     ", (longint) (pCode - SourceBuffer), SymbolName);
			if (verbose >= 3) PrintFoundLine(SymbolStartPos, pCode);
			qprinta(DEBUG_BNF_SPLIT)("\n");
		}
		else
		{
			qprinta(DEBUG_BNF_SPLIT)("%10" PRINTFINT " SKIP  %s\n", (longint) (pCode - SourceBuffer), SymbolName);
		}
	}

	if (pCode != pTempAll)
	{
		if (!tCompressed)
		{
			TreeReturn();
		}
	}
	else
	{
		nTreeSize = nTreeInitSize;
		pTree[nTreeSize] = 0;
	}

	Space--;
	freel(SymbolName);
	return(pCode);
}

void ListBNF(clsGrammar* pGrammar, char* pCode, size_t nBufferSize, bool Optimized)
{
	longint i;

	char* lpSymbolStart = pGrammar->pSymbolNames;
	char* lpCodeStart = pCode;
	char* pSymbol;
	char strSpace[8];
	char CharOut[2] = " ";

	i = 0;
	Space = 0;
	while (i < (longint) nBufferSize)
	{
		if (lpCodeStart[i] == 0)
		{
			Space--;
			i++;
		}
		else if (lpCodeStart[i] == 1)
		{
			Space++;
			i++;
			pSymbol = lpSymbolStart + *((int*) &lpCodeStart[i]);
			i += sizeof(size_t);

			qprintf("\n");
			sprintf(strSpace, "%%%" PRINTFINT "s", 2 * Space);
			qprintf(strSpace, "");
			qprinta(DEBUG_SIZES)("%4" PRINTFINT " - ", i - sizeof(size_t) - 1);
			qprintf("%s", pSymbol);
			qprintf(": ");
		}
		else if (Optimized && lpCodeStart[i] == 2)
		{
			qprintf("%" PRINTFINT, *(longint*) &lpCodeStart[i + 1]);
			i += sizeof(size_t) + 1;
		}
		else
		{
			CharOut[0] = lpCodeStart[i];
			qprintf("%s", CharOut);

			i ++;
		}
	}
}

longint SplitBuffer(clsGrammar* pGrammar, char* Source)
{
	char NearError[96];
	ErrorBestPos = 0;
	if (DoRule(Source, pInitSymbol, 0, pGrammar) != Source + strlen(Source))
	{
		CopyMemory(NearError, ErrorBestPos, min(95, strlen(ErrorBestPos)));
		NearError[min(95, strlen(ErrorBestPos))] = 0;
		qprintf("Content does not match Grammar near:\n\n%s\n\n%s\n\n", NearError, Source);
		return(1);
	}
	qprinta(2)("Script Matches Grammar\n");

	if (verbosemax >= 2)
	{
		qprinta(2)("\nListing Output...\n");
		ListBNF(pGrammar, pTree, nTreeSize);
		qprinta(2)("\nListing finished\n\n");
	}

	nTreeSize = OptimizeScript(&pTree, nTreeSize, pGrammar);

	if (verbosemax >= 2)
	{
		qprinta(2)("\nListing Optimized Output...\n");
		ListBNF(pGrammar, pTree, nTreeSize, true);
		qprinta(2)("\nListing finished\n\n");
	}

	qprinta(2)("Splitting compleeted successfully...\n\n\n\n");

	return(0);
}

longint SplitFile(char* FileName, clsGrammar* pGrammar, bool Save)
{
	longint i;

	qprintf("Opening Source File\n");
	if (!(SourceFileSize = ReadFileToBuffer(FileName, &SourceBuffer, true)))
	{
		qprintf("Error loading Source File\n");
		return(1);
	}

	qprintf("Splitting Source file\n");

	if (SplitBuffer(pGrammar, SourceBuffer))
	{
		return(1);
	}

	if (Save)
	{
		char* NewFileName;
		if ((NewFileName = (char*) mallocl(strlen(FileName) + 5, "SplitFile-NewFileName")) == 0)
		{
			qprintf("Memory Allocation Error\n");
			return(1);
		}
		strcpy(NewFileName, FileName);
		for (i = (longint) strlen(NewFileName) - 1;i > 0;i--)
		{
			if (NewFileName[i] == '.')
			{
				break;
			}
		}
		if (i == 0)
		{
			i = (longint) strlen(NewFileName);
		}
		NewFileName[i] = 0;
		strcat(NewFileName, ".kfa");

		qprintf("Writing Output to %s\n", NewFileName);

		freel(NewFileName);
	}

	nTreeSize = 0;
	
	qprinta(2)("Freeing Memory\n");
	freel(SourceBuffer);

	qprinta(2)("Finished\n");
	return(0);
}

#endif