void OptimizeScriptA(clsGrammar* pGrammar, unsigned char*& pCode, unsigned char*& pNewCode, longint sourceCode = 0, unsigned char* pSymbol = (unsigned char*) "")
{
	bool SymbolSourceCode;
	char stopCode;
	char tempDigit[21];
	longint i;

	do
	{
		if (*pCode == 1)
		{
			if (!sourceCode)
			{
				SymbolSourceCode = (*(longint*)(pGrammar->RedirExtract + *(longint*)(pCode + 1)) != 0);
				if (qon_DebugOutput || logverbose >= 2)
				{
					if (SymbolSourceCode)
					{
						qprinta(DEBUG_BNF_SPLIT)("\tUsing Text for Symbol %s\n", pGrammar->pSymbolNames + *(longint*)(pCode + 1));
					}
					else
					{
						qprinta(DEBUG_BNF_SPLIT)("\tSkipping Text for Symbol %s\n", pGrammar->pSymbolNames + *(longint*)(pCode + 1));
					}
				}
			}
			if (*(longint*)(pGrammar->RedirFuncs + *(longint*)(pCode + 1)) || *(longint*)(pGrammar->RedirExtract + *(longint*)(pCode + 1))
				|| strcmp(pGrammar->pSymbolNames + *(longint*)(pCode + 1), "order_block") == 0)
			{
				qprinta(DEBUG_BNF_SPLIT)("\tUsing Symbol: %s\n", pGrammar->pSymbolNames + *(longint*)(pCode + 1));
				CopyMemory(pNewCode, pCode, sizeof(size_t) + 1);
				pCode += sizeof(size_t) + 1;
				pNewCode += sizeof(size_t) + 1;
				OptimizeScriptA(pGrammar, pCode, pNewCode, sourceCode || SymbolSourceCode, pCode - sizeof(size_t));
				*pNewCode = 0;
				pCode++;
				pNewCode++;
			}
			else
			{
				qprinta(DEBUG_BNF_SPLIT)("\tSkipping Symbol: %s\n", pGrammar->pSymbolNames + *(longint*)(pCode + 1));
				pCode += sizeof(size_t) + 1;
				OptimizeScriptA(pGrammar, pCode, pNewCode, sourceCode || SymbolSourceCode, pCode - sizeof(size_t));
				pCode++;
			}
		}
		else
		{
			if (strcmp((char*) pGrammar->pSymbolNames + *(longint*) pSymbol, "val") == 0)
			{
				i = 0;
				while (*pCode >= 10)
				{
					tempDigit[i++] = *(pCode++);
				}
				tempDigit[i] = 0;
				*(pNewCode++) = 2;
				*(longint*)pNewCode = (longint) atoi(tempDigit);
				pNewCode += sizeof(size_t);
			}
			else
			{
				stopCode = 0;
				if (strcmp((char*) pGrammar->pSymbolNames + *(longint*) pSymbol, "string") == 0 && (*pCode == '"' || *pCode == '\''))
				{
					stopCode = *(pCode++);
				}
				while (*pCode >= 10 && *pCode != stopCode)
				{
					if (sourceCode)
					{
						*(pNewCode++) = *pCode;
					}
					pCode++;
				}
				if (*pCode == stopCode && stopCode >= 10)
				{
					pCode++;
				}
			}
		}
	} while (*pCode);
}

size_t OptimizeScript(char** ppScript, size_t nScriptSize, clsGrammar* pGrammar)
{
	char* pScript;
	char* pNewScript;
	unsigned char* pCode;
	unsigned char* pNewCode;
	unsigned char* pOldCode;

	qprinta(DEBUG_BNF_SPLIT)("Optimizing Script...\n");

	pScript = (char*) mallocl(nScriptSize, "OptimizeScript-pScript");

	pCode = (unsigned char*) *ppScript;
	pNewCode = (unsigned char*) pScript;

	pOldCode = pCode;

	OptimizeScriptA(pGrammar, pCode, pNewCode);
	qprinta(2)("Optimizing Done...");
	qprinta(DEBUG_SIZES)(" Old Size: %" PRINTFINT ", New Size: %" PRINTFINT " (Run From %" PRINTFINT " - %" PRINTFINT ")", nScriptSize, (longint) (size_t) (pNewCode - (unsigned char*) pScript), (longint) (size_t) pOldCode, (longint) (size_t) pCode);
	qprinta(2)("\n");
	if (pCode - pOldCode != nScriptSize)
	{
		qprintf("Error optimizing script, Source was not completely proceeded...\n");
		qon_quitprog();
	}
	nScriptSize = pNewCode - (unsigned char*) pScript;
	
	pNewScript = (char*) mallocl(max(1, nScriptSize), "OptimizeScript-pNewScript");
	*pNewScript = 0;
	CopyMemory(pNewScript, pScript, nScriptSize);
	freel(pScript);
	freel(*ppScript);
	*ppScript = pNewScript;

	nTreeSizeMax2 = max(nTreeSizeMax2, nScriptSize);

	return(max(1, nScriptSize));
}

